# coding: utf-8

"""
    OneRoster OpenAPI (JSON) Definition

    The OneRoster service binding is available in WSDL/XSD and REST/JSON. The model is based upon the IMS PSM modelling approach.  # noqa: E501

    OpenAPI spec version: 1.1
    Contact: lmattson@imsglobal.org
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from oneroster_client.api_client import ApiClient


class AcademicSessionsManagementApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def get_academic_session(self, sourced_id, **kwargs):  # noqa: E501
        """The REST read request message for the getAcademicSession() API call.  # noqa: E501

        To read, get, a specific academic session.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_academic_session(sourced_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str sourced_id: The unique identifier for this academic session. (required)
        :return: SingleAcademicSessionType
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_academic_session_with_http_info(sourced_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_academic_session_with_http_info(sourced_id, **kwargs)  # noqa: E501
            return data

    def get_academic_session_with_http_info(self, sourced_id, **kwargs):  # noqa: E501
        """The REST read request message for the getAcademicSession() API call.  # noqa: E501

        To read, get, a specific academic session.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_academic_session_with_http_info(sourced_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str sourced_id: The unique identifier for this academic session. (required)
        :return: SingleAcademicSessionType
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['sourced_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_academic_session" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'sourced_id' is set
        if ('sourced_id' not in params or
                params['sourced_id'] is None):
            raise ValueError("Missing the required parameter `sourced_id` when calling `get_academic_session`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'sourced_id' in params:
            path_params['sourcedId'] = params['sourced_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['OAuth2Security']  # noqa: E501

        return self.api_client.call_api(
            '/academicSessions/{sourcedId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='SingleAcademicSessionType',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_academic_sessions(self, **kwargs):  # noqa: E501
        """The REST read request message for the getAcademicSessions() API call.  # noqa: E501

        To read, get, a collection of academic sessions i.e. all academic sessions.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_academic_sessions(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int limit: To define the download segmentation value i.e. the maximum number of records to be contained in the response.
        :param int offset: The number of the first record to be supplied in the segmented response message.
        :param str continuation_token: Allows the client to resume retrieving results from where the previous page left off
        :param str sort: Identifies the sort criteria to be used for the records in the response message. Use with the orderBy parameter.
        :param str order_by: The form of ordering for response to the sorted request i.e. ascending (asc) or descending (desc).
        :param str filter: The filtering rules to be applied when identifying the records to be supplied in the response message.
        :param list[str] fields: To identify the range of fields that should be supplied in the response message.
        :return: MultipleAcademicSessionsType
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_academic_sessions_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.get_academic_sessions_with_http_info(**kwargs)  # noqa: E501
            return data

    def get_academic_sessions_with_http_info(self, **kwargs):  # noqa: E501
        """The REST read request message for the getAcademicSessions() API call.  # noqa: E501

        To read, get, a collection of academic sessions i.e. all academic sessions.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_academic_sessions_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int limit: To define the download segmentation value i.e. the maximum number of records to be contained in the response.
        :param int offset: The number of the first record to be supplied in the segmented response message.
        :param str continuation_token: Allows the client to resume retrieving results from where the previous page left off
        :param str sort: Identifies the sort criteria to be used for the records in the response message. Use with the orderBy parameter.
        :param str order_by: The form of ordering for response to the sorted request i.e. ascending (asc) or descending (desc).
        :param str filter: The filtering rules to be applied when identifying the records to be supplied in the response message.
        :param list[str] fields: To identify the range of fields that should be supplied in the response message.
        :return: MultipleAcademicSessionsType
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['limit', 'offset', 'continuation_token', 'sort', 'order_by', 'filter', 'fields']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_academic_sessions" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'limit' in params:
            query_params.append(('limit', params['limit']))  # noqa: E501
        if 'offset' in params:
            query_params.append(('offset', params['offset']))  # noqa: E501
        if 'continuation_token' in params:
            query_params.append(('continuationToken', params['continuation_token']))  # noqa: E501
        if 'sort' in params:
            query_params.append(('sort', params['sort']))  # noqa: E501
        if 'order_by' in params:
            query_params.append(('orderBy', params['order_by']))  # noqa: E501
        if 'filter' in params:
            query_params.append(('filter', params['filter']))  # noqa: E501
        if 'fields' in params:
            query_params.append(('fields', params['fields']))  # noqa: E501
            collection_formats['fields'] = 'csv'  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['OAuth2Security']  # noqa: E501

        return self.api_client.call_api(
            '/academicSessions', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='MultipleAcademicSessionsType',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
