# coding: utf-8

"""
    OneRoster OpenAPI (JSON) Definition

    The OneRoster service binding is available in WSDL/XSD and REST/JSON. The model is based upon the IMS PSM modelling approach.  # noqa: E501

    OpenAPI spec version: 1.1
    Contact: lmattson@imsglobal.org
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from oneroster_client.api_client import ApiClient


class ClassesManagementApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def get_class(self, sourced_id, **kwargs):  # noqa: E501
        """The REST read request message for the getClass() API call.  # noqa: E501

        To read, get, a specific class.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_class(sourced_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str sourced_id: The unique identifier for this class. (required)
        :return: SingleClassType
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_class_with_http_info(sourced_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_class_with_http_info(sourced_id, **kwargs)  # noqa: E501
            return data

    def get_class_with_http_info(self, sourced_id, **kwargs):  # noqa: E501
        """The REST read request message for the getClass() API call.  # noqa: E501

        To read, get, a specific class.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_class_with_http_info(sourced_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str sourced_id: The unique identifier for this class. (required)
        :return: SingleClassType
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['sourced_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_class" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'sourced_id' is set
        if ('sourced_id' not in params or
                params['sourced_id'] is None):
            raise ValueError("Missing the required parameter `sourced_id` when calling `get_class`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'sourced_id' in params:
            path_params['sourcedId'] = params['sourced_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['OAuth2Security']  # noqa: E501

        return self.api_client.call_api(
            '/classes/{sourcedId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='SingleClassType',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_classes(self, **kwargs):  # noqa: E501
        """The REST read request message for the getClasses() API call.  # noqa: E501

        To read, get, a collection of classes i.e. all classes.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_classes(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int limit: To define the download segmentation value i.e. the maximum number of records to be contained in the response.
        :param int offset: The number of the first record to be supplied in the segmented response message.
        :param str continuation_token: Allows the client to resume retrieving results from where the previous page left off
        :param str sort: Identifies the sort criteria to be used for the records in the response message. Use with the orderBy parameter.
        :param str order_by: The form of ordering for response to the sorted request i.e. ascending (asc) or descending (desc).
        :param str filter: The filtering rules to be applied when identifying the records to be supplied in the response message.
        :param list[str] fields: To identify the range of fields that should be supplied in the response message.
        :return: ClassesType
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_classes_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.get_classes_with_http_info(**kwargs)  # noqa: E501
            return data

    def get_classes_with_http_info(self, **kwargs):  # noqa: E501
        """The REST read request message for the getClasses() API call.  # noqa: E501

        To read, get, a collection of classes i.e. all classes.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_classes_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int limit: To define the download segmentation value i.e. the maximum number of records to be contained in the response.
        :param int offset: The number of the first record to be supplied in the segmented response message.
        :param str continuation_token: Allows the client to resume retrieving results from where the previous page left off
        :param str sort: Identifies the sort criteria to be used for the records in the response message. Use with the orderBy parameter.
        :param str order_by: The form of ordering for response to the sorted request i.e. ascending (asc) or descending (desc).
        :param str filter: The filtering rules to be applied when identifying the records to be supplied in the response message.
        :param list[str] fields: To identify the range of fields that should be supplied in the response message.
        :return: ClassesType
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['limit', 'offset', 'continuation_token', 'sort', 'order_by', 'filter', 'fields']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_classes" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'limit' in params:
            query_params.append(('limit', params['limit']))  # noqa: E501
        if 'offset' in params:
            query_params.append(('offset', params['offset']))  # noqa: E501
        if 'continuation_token' in params:
            query_params.append(('continuationToken', params['continuation_token']))  # noqa: E501
        if 'sort' in params:
            query_params.append(('sort', params['sort']))  # noqa: E501
        if 'order_by' in params:
            query_params.append(('orderBy', params['order_by']))  # noqa: E501
        if 'filter' in params:
            query_params.append(('filter', params['filter']))  # noqa: E501
        if 'fields' in params:
            query_params.append(('fields', params['fields']))  # noqa: E501
            collection_formats['fields'] = 'csv'  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['OAuth2Security']  # noqa: E501

        return self.api_client.call_api(
            '/classes', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ClassesType',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_classes_for_course(self, course_sourced_id, **kwargs):  # noqa: E501
        """The REST read request message for the getClassesForCourse() API call.  # noqa: E501

        ...not supplied...  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_classes_for_course(course_sourced_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str course_sourced_id: ...tbd... (required)
        :param int limit: To define the download segmentation value i.e. the maximum number of records to be contained in the response.
        :param int offset: The number of the first record to be supplied in the segmented response message.
        :param str continuation_token: Allows the client to resume retrieving results from where the previous page left off
        :param str sort: Identifies the sort criteria to be used for the records in the response message. Use with the orderBy parameter.
        :param str order_by: The form of ordering for response to the sorted request i.e. ascending (asc) or descending (desc).
        :param str filter: The filtering rules to be applied when identifying the records to be supplied in the response message.
        :param list[str] fields: To identify the range of fields that should be supplied in the response message.
        :return: ClassesType
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_classes_for_course_with_http_info(course_sourced_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_classes_for_course_with_http_info(course_sourced_id, **kwargs)  # noqa: E501
            return data

    def get_classes_for_course_with_http_info(self, course_sourced_id, **kwargs):  # noqa: E501
        """The REST read request message for the getClassesForCourse() API call.  # noqa: E501

        ...not supplied...  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_classes_for_course_with_http_info(course_sourced_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str course_sourced_id: ...tbd... (required)
        :param int limit: To define the download segmentation value i.e. the maximum number of records to be contained in the response.
        :param int offset: The number of the first record to be supplied in the segmented response message.
        :param str continuation_token: Allows the client to resume retrieving results from where the previous page left off
        :param str sort: Identifies the sort criteria to be used for the records in the response message. Use with the orderBy parameter.
        :param str order_by: The form of ordering for response to the sorted request i.e. ascending (asc) or descending (desc).
        :param str filter: The filtering rules to be applied when identifying the records to be supplied in the response message.
        :param list[str] fields: To identify the range of fields that should be supplied in the response message.
        :return: ClassesType
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['course_sourced_id', 'limit', 'offset', 'continuation_token', 'sort', 'order_by', 'filter', 'fields']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_classes_for_course" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'course_sourced_id' is set
        if ('course_sourced_id' not in params or
                params['course_sourced_id'] is None):
            raise ValueError("Missing the required parameter `course_sourced_id` when calling `get_classes_for_course`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'course_sourced_id' in params:
            path_params['courseSourcedId'] = params['course_sourced_id']  # noqa: E501

        query_params = []
        if 'limit' in params:
            query_params.append(('limit', params['limit']))  # noqa: E501
        if 'offset' in params:
            query_params.append(('offset', params['offset']))  # noqa: E501
        if 'continuation_token' in params:
            query_params.append(('continuationToken', params['continuation_token']))  # noqa: E501
        if 'sort' in params:
            query_params.append(('sort', params['sort']))  # noqa: E501
        if 'order_by' in params:
            query_params.append(('orderBy', params['order_by']))  # noqa: E501
        if 'filter' in params:
            query_params.append(('filter', params['filter']))  # noqa: E501
        if 'fields' in params:
            query_params.append(('fields', params['fields']))  # noqa: E501
            collection_formats['fields'] = 'csv'  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['OAuth2Security']  # noqa: E501

        return self.api_client.call_api(
            '/courses/{courseSourcedId}/classes', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ClassesType',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_classes_for_school(self, school_sourced_id, **kwargs):  # noqa: E501
        """The REST read request message for the getClassesForSchool() API call.  # noqa: E501

        ...not supplied...  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_classes_for_school(school_sourced_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str school_sourced_id: ...tbd... (required)
        :param int limit: To define the download segmentation value i.e. the maximum number of records to be contained in the response.
        :param int offset: The number of the first record to be supplied in the segmented response message.
        :param str continuation_token: Allows the client to resume retrieving results from where the previous page left off
        :param str sort: Identifies the sort criteria to be used for the records in the response message. Use with the orderBy parameter.
        :param str order_by: The form of ordering for response to the sorted request i.e. ascending (asc) or descending (desc).
        :param str filter: The filtering rules to be applied when identifying the records to be supplied in the response message.
        :param list[str] fields: To identify the range of fields that should be supplied in the response message.
        :return: ClassesType
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_classes_for_school_with_http_info(school_sourced_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_classes_for_school_with_http_info(school_sourced_id, **kwargs)  # noqa: E501
            return data

    def get_classes_for_school_with_http_info(self, school_sourced_id, **kwargs):  # noqa: E501
        """The REST read request message for the getClassesForSchool() API call.  # noqa: E501

        ...not supplied...  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_classes_for_school_with_http_info(school_sourced_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str school_sourced_id: ...tbd... (required)
        :param int limit: To define the download segmentation value i.e. the maximum number of records to be contained in the response.
        :param int offset: The number of the first record to be supplied in the segmented response message.
        :param str continuation_token: Allows the client to resume retrieving results from where the previous page left off
        :param str sort: Identifies the sort criteria to be used for the records in the response message. Use with the orderBy parameter.
        :param str order_by: The form of ordering for response to the sorted request i.e. ascending (asc) or descending (desc).
        :param str filter: The filtering rules to be applied when identifying the records to be supplied in the response message.
        :param list[str] fields: To identify the range of fields that should be supplied in the response message.
        :return: ClassesType
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['school_sourced_id', 'limit', 'offset', 'continuation_token', 'sort', 'order_by', 'filter', 'fields']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_classes_for_school" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'school_sourced_id' is set
        if ('school_sourced_id' not in params or
                params['school_sourced_id'] is None):
            raise ValueError("Missing the required parameter `school_sourced_id` when calling `get_classes_for_school`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'school_sourced_id' in params:
            path_params['schoolSourcedId'] = params['school_sourced_id']  # noqa: E501

        query_params = []
        if 'limit' in params:
            query_params.append(('limit', params['limit']))  # noqa: E501
        if 'offset' in params:
            query_params.append(('offset', params['offset']))  # noqa: E501
        if 'continuation_token' in params:
            query_params.append(('continuationToken', params['continuation_token']))  # noqa: E501
        if 'sort' in params:
            query_params.append(('sort', params['sort']))  # noqa: E501
        if 'order_by' in params:
            query_params.append(('orderBy', params['order_by']))  # noqa: E501
        if 'filter' in params:
            query_params.append(('filter', params['filter']))  # noqa: E501
        if 'fields' in params:
            query_params.append(('fields', params['fields']))  # noqa: E501
            collection_formats['fields'] = 'csv'  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['OAuth2Security']  # noqa: E501

        return self.api_client.call_api(
            '/schools/{schoolSourcedId}/classes', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ClassesType',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_classes_for_student(self, student_sourced_id, **kwargs):  # noqa: E501
        """The REST read request message for the getClassesForStudent() API call.  # noqa: E501

        ...not supplied...  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_classes_for_student(student_sourced_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str student_sourced_id: ...tbd... (required)
        :param int limit: To define the download segmentation value i.e. the maximum number of records to be contained in the response.
        :param int offset: The number of the first record to be supplied in the segmented response message.
        :param str continuation_token: Allows the client to resume retrieving results from where the previous page left off
        :param str sort: Identifies the sort criteria to be used for the records in the response message. Use with the orderBy parameter.
        :param str order_by: The form of ordering for response to the sorted request i.e. ascending (asc) or descending (desc).
        :param str filter: The filtering rules to be applied when identifying the records to be supplied in the response message.
        :param list[str] fields: To identify the range of fields that should be supplied in the response message.
        :return: ClassesType
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_classes_for_student_with_http_info(student_sourced_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_classes_for_student_with_http_info(student_sourced_id, **kwargs)  # noqa: E501
            return data

    def get_classes_for_student_with_http_info(self, student_sourced_id, **kwargs):  # noqa: E501
        """The REST read request message for the getClassesForStudent() API call.  # noqa: E501

        ...not supplied...  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_classes_for_student_with_http_info(student_sourced_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str student_sourced_id: ...tbd... (required)
        :param int limit: To define the download segmentation value i.e. the maximum number of records to be contained in the response.
        :param int offset: The number of the first record to be supplied in the segmented response message.
        :param str continuation_token: Allows the client to resume retrieving results from where the previous page left off
        :param str sort: Identifies the sort criteria to be used for the records in the response message. Use with the orderBy parameter.
        :param str order_by: The form of ordering for response to the sorted request i.e. ascending (asc) or descending (desc).
        :param str filter: The filtering rules to be applied when identifying the records to be supplied in the response message.
        :param list[str] fields: To identify the range of fields that should be supplied in the response message.
        :return: ClassesType
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['student_sourced_id', 'limit', 'offset', 'continuation_token', 'sort', 'order_by', 'filter', 'fields']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_classes_for_student" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'student_sourced_id' is set
        if ('student_sourced_id' not in params or
                params['student_sourced_id'] is None):
            raise ValueError("Missing the required parameter `student_sourced_id` when calling `get_classes_for_student`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'student_sourced_id' in params:
            path_params['studentSourcedId'] = params['student_sourced_id']  # noqa: E501

        query_params = []
        if 'limit' in params:
            query_params.append(('limit', params['limit']))  # noqa: E501
        if 'offset' in params:
            query_params.append(('offset', params['offset']))  # noqa: E501
        if 'continuation_token' in params:
            query_params.append(('continuationToken', params['continuation_token']))  # noqa: E501
        if 'sort' in params:
            query_params.append(('sort', params['sort']))  # noqa: E501
        if 'order_by' in params:
            query_params.append(('orderBy', params['order_by']))  # noqa: E501
        if 'filter' in params:
            query_params.append(('filter', params['filter']))  # noqa: E501
        if 'fields' in params:
            query_params.append(('fields', params['fields']))  # noqa: E501
            collection_formats['fields'] = 'csv'  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['OAuth2Security']  # noqa: E501

        return self.api_client.call_api(
            '/students/{studentSourcedId}/classes', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ClassesType',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_classes_for_teacher(self, teacher_sourced_id, **kwargs):  # noqa: E501
        """The REST read request message for the getClassesForTeacher() API call.  # noqa: E501

        ...not supplied...  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_classes_for_teacher(teacher_sourced_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str teacher_sourced_id: ...tbd... (required)
        :param int limit: To define the download segmentation value i.e. the maximum number of records to be contained in the response.
        :param int offset: The number of the first record to be supplied in the segmented response message.
        :param str continuation_token: Allows the client to resume retrieving results from where the previous page left off
        :param str sort: Identifies the sort criteria to be used for the records in the response message. Use with the orderBy parameter.
        :param str order_by: The form of ordering for response to the sorted request i.e. ascending (asc) or descending (desc).
        :param str filter: The filtering rules to be applied when identifying the records to be supplied in the response message.
        :param list[str] fields: To identify the range of fields that should be supplied in the response message.
        :return: ClassesType
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_classes_for_teacher_with_http_info(teacher_sourced_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_classes_for_teacher_with_http_info(teacher_sourced_id, **kwargs)  # noqa: E501
            return data

    def get_classes_for_teacher_with_http_info(self, teacher_sourced_id, **kwargs):  # noqa: E501
        """The REST read request message for the getClassesForTeacher() API call.  # noqa: E501

        ...not supplied...  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_classes_for_teacher_with_http_info(teacher_sourced_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str teacher_sourced_id: ...tbd... (required)
        :param int limit: To define the download segmentation value i.e. the maximum number of records to be contained in the response.
        :param int offset: The number of the first record to be supplied in the segmented response message.
        :param str continuation_token: Allows the client to resume retrieving results from where the previous page left off
        :param str sort: Identifies the sort criteria to be used for the records in the response message. Use with the orderBy parameter.
        :param str order_by: The form of ordering for response to the sorted request i.e. ascending (asc) or descending (desc).
        :param str filter: The filtering rules to be applied when identifying the records to be supplied in the response message.
        :param list[str] fields: To identify the range of fields that should be supplied in the response message.
        :return: ClassesType
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['teacher_sourced_id', 'limit', 'offset', 'continuation_token', 'sort', 'order_by', 'filter', 'fields']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_classes_for_teacher" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'teacher_sourced_id' is set
        if ('teacher_sourced_id' not in params or
                params['teacher_sourced_id'] is None):
            raise ValueError("Missing the required parameter `teacher_sourced_id` when calling `get_classes_for_teacher`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'teacher_sourced_id' in params:
            path_params['teacherSourcedId'] = params['teacher_sourced_id']  # noqa: E501

        query_params = []
        if 'limit' in params:
            query_params.append(('limit', params['limit']))  # noqa: E501
        if 'offset' in params:
            query_params.append(('offset', params['offset']))  # noqa: E501
        if 'continuation_token' in params:
            query_params.append(('continuationToken', params['continuation_token']))  # noqa: E501
        if 'sort' in params:
            query_params.append(('sort', params['sort']))  # noqa: E501
        if 'order_by' in params:
            query_params.append(('orderBy', params['order_by']))  # noqa: E501
        if 'filter' in params:
            query_params.append(('filter', params['filter']))  # noqa: E501
        if 'fields' in params:
            query_params.append(('fields', params['fields']))  # noqa: E501
            collection_formats['fields'] = 'csv'  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['OAuth2Security']  # noqa: E501

        return self.api_client.call_api(
            '/teachers/{teacherSourcedId}/classes', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ClassesType',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_classes_for_term(self, term_sourced_id, **kwargs):  # noqa: E501
        """The REST read request message for the getClassesForTerm() API call.  # noqa: E501

        ...not supplied...  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_classes_for_term(term_sourced_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str term_sourced_id: ...tbd... (required)
        :param int limit: To define the download segmentation value i.e. the maximum number of records to be contained in the response.
        :param int offset: The number of the first record to be supplied in the segmented response message.
        :param str continuation_token: Allows the client to resume retrieving results from where the previous page left off
        :param str sort: Identifies the sort criteria to be used for the records in the response message. Use with the orderBy parameter.
        :param str order_by: The form of ordering for response to the sorted request i.e. ascending (asc) or descending (desc).
        :param str filter: The filtering rules to be applied when identifying the records to be supplied in the response message.
        :param list[str] fields: To identify the range of fields that should be supplied in the response message.
        :return: ClassesType
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_classes_for_term_with_http_info(term_sourced_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_classes_for_term_with_http_info(term_sourced_id, **kwargs)  # noqa: E501
            return data

    def get_classes_for_term_with_http_info(self, term_sourced_id, **kwargs):  # noqa: E501
        """The REST read request message for the getClassesForTerm() API call.  # noqa: E501

        ...not supplied...  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_classes_for_term_with_http_info(term_sourced_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str term_sourced_id: ...tbd... (required)
        :param int limit: To define the download segmentation value i.e. the maximum number of records to be contained in the response.
        :param int offset: The number of the first record to be supplied in the segmented response message.
        :param str continuation_token: Allows the client to resume retrieving results from where the previous page left off
        :param str sort: Identifies the sort criteria to be used for the records in the response message. Use with the orderBy parameter.
        :param str order_by: The form of ordering for response to the sorted request i.e. ascending (asc) or descending (desc).
        :param str filter: The filtering rules to be applied when identifying the records to be supplied in the response message.
        :param list[str] fields: To identify the range of fields that should be supplied in the response message.
        :return: ClassesType
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['term_sourced_id', 'limit', 'offset', 'continuation_token', 'sort', 'order_by', 'filter', 'fields']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_classes_for_term" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'term_sourced_id' is set
        if ('term_sourced_id' not in params or
                params['term_sourced_id'] is None):
            raise ValueError("Missing the required parameter `term_sourced_id` when calling `get_classes_for_term`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'term_sourced_id' in params:
            path_params['termSourcedId'] = params['term_sourced_id']  # noqa: E501

        query_params = []
        if 'limit' in params:
            query_params.append(('limit', params['limit']))  # noqa: E501
        if 'offset' in params:
            query_params.append(('offset', params['offset']))  # noqa: E501
        if 'continuation_token' in params:
            query_params.append(('continuationToken', params['continuation_token']))  # noqa: E501
        if 'sort' in params:
            query_params.append(('sort', params['sort']))  # noqa: E501
        if 'order_by' in params:
            query_params.append(('orderBy', params['order_by']))  # noqa: E501
        if 'filter' in params:
            query_params.append(('filter', params['filter']))  # noqa: E501
        if 'fields' in params:
            query_params.append(('fields', params['fields']))  # noqa: E501
            collection_formats['fields'] = 'csv'  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['OAuth2Security']  # noqa: E501

        return self.api_client.call_api(
            '/terms/{termSourcedId}/classes', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ClassesType',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_classes_for_user(self, user_sourced_id, **kwargs):  # noqa: E501
        """The REST read request message for the getClassesForUser() API call.  # noqa: E501

        ...not supplied...  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_classes_for_user(user_sourced_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str user_sourced_id: ...tbd... (required)
        :param int limit: To define the download segmentation value i.e. the maximum number of records to be contained in the response.
        :param int offset: The number of the first record to be supplied in the segmented response message.
        :param str continuation_token: Allows the client to resume retrieving results from where the previous page left off
        :param str sort: Identifies the sort criteria to be used for the records in the response message. Use with the orderBy parameter.
        :param str order_by: The form of ordering for response to the sorted request i.e. ascending (asc) or descending (desc).
        :param str filter: The filtering rules to be applied when identifying the records to be supplied in the response message.
        :param list[str] fields: To identify the range of fields that should be supplied in the response message.
        :return: ClassesType
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_classes_for_user_with_http_info(user_sourced_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_classes_for_user_with_http_info(user_sourced_id, **kwargs)  # noqa: E501
            return data

    def get_classes_for_user_with_http_info(self, user_sourced_id, **kwargs):  # noqa: E501
        """The REST read request message for the getClassesForUser() API call.  # noqa: E501

        ...not supplied...  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_classes_for_user_with_http_info(user_sourced_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str user_sourced_id: ...tbd... (required)
        :param int limit: To define the download segmentation value i.e. the maximum number of records to be contained in the response.
        :param int offset: The number of the first record to be supplied in the segmented response message.
        :param str continuation_token: Allows the client to resume retrieving results from where the previous page left off
        :param str sort: Identifies the sort criteria to be used for the records in the response message. Use with the orderBy parameter.
        :param str order_by: The form of ordering for response to the sorted request i.e. ascending (asc) or descending (desc).
        :param str filter: The filtering rules to be applied when identifying the records to be supplied in the response message.
        :param list[str] fields: To identify the range of fields that should be supplied in the response message.
        :return: ClassesType
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['user_sourced_id', 'limit', 'offset', 'continuation_token', 'sort', 'order_by', 'filter', 'fields']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_classes_for_user" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'user_sourced_id' is set
        if ('user_sourced_id' not in params or
                params['user_sourced_id'] is None):
            raise ValueError("Missing the required parameter `user_sourced_id` when calling `get_classes_for_user`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'user_sourced_id' in params:
            path_params['userSourcedId'] = params['user_sourced_id']  # noqa: E501

        query_params = []
        if 'limit' in params:
            query_params.append(('limit', params['limit']))  # noqa: E501
        if 'offset' in params:
            query_params.append(('offset', params['offset']))  # noqa: E501
        if 'continuation_token' in params:
            query_params.append(('continuationToken', params['continuation_token']))  # noqa: E501
        if 'sort' in params:
            query_params.append(('sort', params['sort']))  # noqa: E501
        if 'order_by' in params:
            query_params.append(('orderBy', params['order_by']))  # noqa: E501
        if 'filter' in params:
            query_params.append(('filter', params['filter']))  # noqa: E501
        if 'fields' in params:
            query_params.append(('fields', params['fields']))  # noqa: E501
            collection_formats['fields'] = 'csv'  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['OAuth2Security']  # noqa: E501

        return self.api_client.call_api(
            '/users/{userSourcedId}/classes', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ClassesType',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
