# coding: utf-8

"""
    OneRoster OpenAPI (JSON) Definition

    The OneRoster service binding is available in WSDL/XSD and REST/JSON. The model is based upon the IMS PSM modelling approach.  # noqa: E501

    OpenAPI spec version: 1.1
    Contact: lmattson@imsglobal.org
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from oneroster_client.api_client import ApiClient


class ResultsManagementApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def delete_result(self, sourced_id, **kwargs):  # noqa: E501
        """The REST delete request message for the deleteResult() API call.  # noqa: E501

        ...not supplied...  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_result(sourced_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str sourced_id: ...tbd... (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.delete_result_with_http_info(sourced_id, **kwargs)  # noqa: E501
        else:
            (data) = self.delete_result_with_http_info(sourced_id, **kwargs)  # noqa: E501
            return data

    def delete_result_with_http_info(self, sourced_id, **kwargs):  # noqa: E501
        """The REST delete request message for the deleteResult() API call.  # noqa: E501

        ...not supplied...  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_result_with_http_info(sourced_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str sourced_id: ...tbd... (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['sourced_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_result" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'sourced_id' is set
        if ('sourced_id' not in params or
                params['sourced_id'] is None):
            raise ValueError("Missing the required parameter `sourced_id` when calling `delete_result`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'sourced_id' in params:
            path_params['sourcedId'] = params['sourced_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['OAuth2Security']  # noqa: E501

        return self.api_client.call_api(
            '/results/{sourcedId}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_result(self, sourced_id, **kwargs):  # noqa: E501
        """The REST read request message for the getResult() API call.  # noqa: E501

        ...not supplied...  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_result(sourced_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str sourced_id: ...tbd... (required)
        :return: SingleResultType
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_result_with_http_info(sourced_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_result_with_http_info(sourced_id, **kwargs)  # noqa: E501
            return data

    def get_result_with_http_info(self, sourced_id, **kwargs):  # noqa: E501
        """The REST read request message for the getResult() API call.  # noqa: E501

        ...not supplied...  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_result_with_http_info(sourced_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str sourced_id: ...tbd... (required)
        :return: SingleResultType
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['sourced_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_result" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'sourced_id' is set
        if ('sourced_id' not in params or
                params['sourced_id'] is None):
            raise ValueError("Missing the required parameter `sourced_id` when calling `get_result`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'sourced_id' in params:
            path_params['sourcedId'] = params['sourced_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['OAuth2Security']  # noqa: E501

        return self.api_client.call_api(
            '/results/{sourcedId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='SingleResultType',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_results(self, **kwargs):  # noqa: E501
        """The REST read request message for the getResults() API call.  # noqa: E501

        ...not supplied...  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_results(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int limit: To define the download segmentation value i.e. the maximum number of records to be contained in the response.
        :param int offset: The number of the first record to be supplied in the segmented response message.
        :param str continuation_token: Allows the client to resume retrieving results from where the previous page left off
        :param str sort: Identifies the sort criteria to be used for the records in the response message. Use with the orderBy parameter.
        :param str order_by: The form of ordering for response to the sorted request i.e. ascending (asc) or descending (desc).
        :param str filter: The filtering rules to be applied when identifying the records to be supplied in the response message.
        :param list[str] fields: To identify the range of fields that should be supplied in the response message.
        :return: ResultsType
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_results_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.get_results_with_http_info(**kwargs)  # noqa: E501
            return data

    def get_results_with_http_info(self, **kwargs):  # noqa: E501
        """The REST read request message for the getResults() API call.  # noqa: E501

        ...not supplied...  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_results_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int limit: To define the download segmentation value i.e. the maximum number of records to be contained in the response.
        :param int offset: The number of the first record to be supplied in the segmented response message.
        :param str continuation_token: Allows the client to resume retrieving results from where the previous page left off
        :param str sort: Identifies the sort criteria to be used for the records in the response message. Use with the orderBy parameter.
        :param str order_by: The form of ordering for response to the sorted request i.e. ascending (asc) or descending (desc).
        :param str filter: The filtering rules to be applied when identifying the records to be supplied in the response message.
        :param list[str] fields: To identify the range of fields that should be supplied in the response message.
        :return: ResultsType
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['limit', 'offset', 'continuation_token', 'sort', 'order_by', 'filter', 'fields']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_results" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'limit' in params:
            query_params.append(('limit', params['limit']))  # noqa: E501
        if 'offset' in params:
            query_params.append(('offset', params['offset']))  # noqa: E501
        if 'continuation_token' in params:
            query_params.append(('continuationToken', params['continuation_token']))  # noqa: E501
        if 'sort' in params:
            query_params.append(('sort', params['sort']))  # noqa: E501
        if 'order_by' in params:
            query_params.append(('orderBy', params['order_by']))  # noqa: E501
        if 'filter' in params:
            query_params.append(('filter', params['filter']))  # noqa: E501
        if 'fields' in params:
            query_params.append(('fields', params['fields']))  # noqa: E501
            collection_formats['fields'] = 'csv'  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['OAuth2Security']  # noqa: E501

        return self.api_client.call_api(
            '/results', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ResultsType',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_results_for_class(self, class_sourced_id, **kwargs):  # noqa: E501
        """The REST read request message for the getResultsForClass() API call.  # noqa: E501

        ...not supplied...  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_results_for_class(class_sourced_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str class_sourced_id: ...tbd... (required)
        :param int limit: To define the download segmentation value i.e. the maximum number of records to be contained in the response.
        :param int offset: The number of the first record to be supplied in the segmented response message.
        :param str continuation_token: Allows the client to resume retrieving results from where the previous page left off
        :param str sort: Identifies the sort criteria to be used for the records in the response message. Use with the orderBy parameter.
        :param str order_by: The form of ordering for response to the sorted request i.e. ascending (asc) or descending (desc).
        :param str filter: The filtering rules to be applied when identifying the records to be supplied in the response message.
        :param list[str] fields: To identify the range of fields that should be supplied in the response message.
        :return: ResultsType
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_results_for_class_with_http_info(class_sourced_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_results_for_class_with_http_info(class_sourced_id, **kwargs)  # noqa: E501
            return data

    def get_results_for_class_with_http_info(self, class_sourced_id, **kwargs):  # noqa: E501
        """The REST read request message for the getResultsForClass() API call.  # noqa: E501

        ...not supplied...  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_results_for_class_with_http_info(class_sourced_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str class_sourced_id: ...tbd... (required)
        :param int limit: To define the download segmentation value i.e. the maximum number of records to be contained in the response.
        :param int offset: The number of the first record to be supplied in the segmented response message.
        :param str continuation_token: Allows the client to resume retrieving results from where the previous page left off
        :param str sort: Identifies the sort criteria to be used for the records in the response message. Use with the orderBy parameter.
        :param str order_by: The form of ordering for response to the sorted request i.e. ascending (asc) or descending (desc).
        :param str filter: The filtering rules to be applied when identifying the records to be supplied in the response message.
        :param list[str] fields: To identify the range of fields that should be supplied in the response message.
        :return: ResultsType
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['class_sourced_id', 'limit', 'offset', 'continuation_token', 'sort', 'order_by', 'filter', 'fields']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_results_for_class" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'class_sourced_id' is set
        if ('class_sourced_id' not in params or
                params['class_sourced_id'] is None):
            raise ValueError("Missing the required parameter `class_sourced_id` when calling `get_results_for_class`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'class_sourced_id' in params:
            path_params['classSourcedId'] = params['class_sourced_id']  # noqa: E501

        query_params = []
        if 'limit' in params:
            query_params.append(('limit', params['limit']))  # noqa: E501
        if 'offset' in params:
            query_params.append(('offset', params['offset']))  # noqa: E501
        if 'continuation_token' in params:
            query_params.append(('continuationToken', params['continuation_token']))  # noqa: E501
        if 'sort' in params:
            query_params.append(('sort', params['sort']))  # noqa: E501
        if 'order_by' in params:
            query_params.append(('orderBy', params['order_by']))  # noqa: E501
        if 'filter' in params:
            query_params.append(('filter', params['filter']))  # noqa: E501
        if 'fields' in params:
            query_params.append(('fields', params['fields']))  # noqa: E501
            collection_formats['fields'] = 'csv'  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['OAuth2Security']  # noqa: E501

        return self.api_client.call_api(
            '/classes/{classSourcedId}/results', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ResultsType',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_results_for_line_item_for_class(self, class_sourced_id, line_item_sourced_id, **kwargs):  # noqa: E501
        """The REST read request message for the getResultsForLineItemForClass() API call.  # noqa: E501

        ...not supplied...  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_results_for_line_item_for_class(class_sourced_id, line_item_sourced_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str class_sourced_id: ...tbd... (required)
        :param str line_item_sourced_id: ...tbd... (required)
        :param int limit: To define the download segmentation value i.e. the maximum number of records to be contained in the response.
        :param int offset: The number of the first record to be supplied in the segmented response message.
        :param str continuation_token: Allows the client to resume retrieving results from where the previous page left off
        :param str sort: Identifies the sort criteria to be used for the records in the response message. Use with the orderBy parameter.
        :param str order_by: The form of ordering for response to the sorted request i.e. ascending (asc) or descending (desc).
        :param str filter: The filtering rules to be applied when identifying the records to be supplied in the response message.
        :param list[str] fields: To identify the range of fields that should be supplied in the response message.
        :return: ResultsType
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_results_for_line_item_for_class_with_http_info(class_sourced_id, line_item_sourced_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_results_for_line_item_for_class_with_http_info(class_sourced_id, line_item_sourced_id, **kwargs)  # noqa: E501
            return data

    def get_results_for_line_item_for_class_with_http_info(self, class_sourced_id, line_item_sourced_id, **kwargs):  # noqa: E501
        """The REST read request message for the getResultsForLineItemForClass() API call.  # noqa: E501

        ...not supplied...  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_results_for_line_item_for_class_with_http_info(class_sourced_id, line_item_sourced_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str class_sourced_id: ...tbd... (required)
        :param str line_item_sourced_id: ...tbd... (required)
        :param int limit: To define the download segmentation value i.e. the maximum number of records to be contained in the response.
        :param int offset: The number of the first record to be supplied in the segmented response message.
        :param str continuation_token: Allows the client to resume retrieving results from where the previous page left off
        :param str sort: Identifies the sort criteria to be used for the records in the response message. Use with the orderBy parameter.
        :param str order_by: The form of ordering for response to the sorted request i.e. ascending (asc) or descending (desc).
        :param str filter: The filtering rules to be applied when identifying the records to be supplied in the response message.
        :param list[str] fields: To identify the range of fields that should be supplied in the response message.
        :return: ResultsType
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['class_sourced_id', 'line_item_sourced_id', 'limit', 'offset', 'continuation_token', 'sort', 'order_by', 'filter', 'fields']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_results_for_line_item_for_class" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'class_sourced_id' is set
        if ('class_sourced_id' not in params or
                params['class_sourced_id'] is None):
            raise ValueError("Missing the required parameter `class_sourced_id` when calling `get_results_for_line_item_for_class`")  # noqa: E501
        # verify the required parameter 'line_item_sourced_id' is set
        if ('line_item_sourced_id' not in params or
                params['line_item_sourced_id'] is None):
            raise ValueError("Missing the required parameter `line_item_sourced_id` when calling `get_results_for_line_item_for_class`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'class_sourced_id' in params:
            path_params['classSourcedId'] = params['class_sourced_id']  # noqa: E501
        if 'line_item_sourced_id' in params:
            path_params['lineItemSourcedId'] = params['line_item_sourced_id']  # noqa: E501

        query_params = []
        if 'limit' in params:
            query_params.append(('limit', params['limit']))  # noqa: E501
        if 'offset' in params:
            query_params.append(('offset', params['offset']))  # noqa: E501
        if 'continuation_token' in params:
            query_params.append(('continuationToken', params['continuation_token']))  # noqa: E501
        if 'sort' in params:
            query_params.append(('sort', params['sort']))  # noqa: E501
        if 'order_by' in params:
            query_params.append(('orderBy', params['order_by']))  # noqa: E501
        if 'filter' in params:
            query_params.append(('filter', params['filter']))  # noqa: E501
        if 'fields' in params:
            query_params.append(('fields', params['fields']))  # noqa: E501
            collection_formats['fields'] = 'csv'  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['OAuth2Security']  # noqa: E501

        return self.api_client.call_api(
            '/classes/{classSourcedId}/lineItems/{lineItemSourcedId}/results', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ResultsType',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_results_for_student_for_class(self, class_sourced_id, student_sourced_id, **kwargs):  # noqa: E501
        """The REST read request message for the getResultsForStudentForClass() API call.  # noqa: E501

        ...not supplied...  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_results_for_student_for_class(class_sourced_id, student_sourced_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str class_sourced_id: ...tbd... (required)
        :param str student_sourced_id: ...tbd... (required)
        :param int limit: To define the download segmentation value i.e. the maximum number of records to be contained in the response.
        :param int offset: The number of the first record to be supplied in the segmented response message.
        :param str continuation_token: Allows the client to resume retrieving results from where the previous page left off
        :param str sort: Identifies the sort criteria to be used for the records in the response message. Use with the orderBy parameter.
        :param str order_by: The form of ordering for response to the sorted request i.e. ascending (asc) or descending (desc).
        :param str filter: The filtering rules to be applied when identifying the records to be supplied in the response message.
        :param list[str] fields: To identify the range of fields that should be supplied in the response message.
        :return: ResultsType
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_results_for_student_for_class_with_http_info(class_sourced_id, student_sourced_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_results_for_student_for_class_with_http_info(class_sourced_id, student_sourced_id, **kwargs)  # noqa: E501
            return data

    def get_results_for_student_for_class_with_http_info(self, class_sourced_id, student_sourced_id, **kwargs):  # noqa: E501
        """The REST read request message for the getResultsForStudentForClass() API call.  # noqa: E501

        ...not supplied...  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_results_for_student_for_class_with_http_info(class_sourced_id, student_sourced_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str class_sourced_id: ...tbd... (required)
        :param str student_sourced_id: ...tbd... (required)
        :param int limit: To define the download segmentation value i.e. the maximum number of records to be contained in the response.
        :param int offset: The number of the first record to be supplied in the segmented response message.
        :param str continuation_token: Allows the client to resume retrieving results from where the previous page left off
        :param str sort: Identifies the sort criteria to be used for the records in the response message. Use with the orderBy parameter.
        :param str order_by: The form of ordering for response to the sorted request i.e. ascending (asc) or descending (desc).
        :param str filter: The filtering rules to be applied when identifying the records to be supplied in the response message.
        :param list[str] fields: To identify the range of fields that should be supplied in the response message.
        :return: ResultsType
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['class_sourced_id', 'student_sourced_id', 'limit', 'offset', 'continuation_token', 'sort', 'order_by', 'filter', 'fields']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_results_for_student_for_class" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'class_sourced_id' is set
        if ('class_sourced_id' not in params or
                params['class_sourced_id'] is None):
            raise ValueError("Missing the required parameter `class_sourced_id` when calling `get_results_for_student_for_class`")  # noqa: E501
        # verify the required parameter 'student_sourced_id' is set
        if ('student_sourced_id' not in params or
                params['student_sourced_id'] is None):
            raise ValueError("Missing the required parameter `student_sourced_id` when calling `get_results_for_student_for_class`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'class_sourced_id' in params:
            path_params['classSourcedId'] = params['class_sourced_id']  # noqa: E501
        if 'student_sourced_id' in params:
            path_params['studentSourcedId'] = params['student_sourced_id']  # noqa: E501

        query_params = []
        if 'limit' in params:
            query_params.append(('limit', params['limit']))  # noqa: E501
        if 'offset' in params:
            query_params.append(('offset', params['offset']))  # noqa: E501
        if 'continuation_token' in params:
            query_params.append(('continuationToken', params['continuation_token']))  # noqa: E501
        if 'sort' in params:
            query_params.append(('sort', params['sort']))  # noqa: E501
        if 'order_by' in params:
            query_params.append(('orderBy', params['order_by']))  # noqa: E501
        if 'filter' in params:
            query_params.append(('filter', params['filter']))  # noqa: E501
        if 'fields' in params:
            query_params.append(('fields', params['fields']))  # noqa: E501
            collection_formats['fields'] = 'csv'  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['OAuth2Security']  # noqa: E501

        return self.api_client.call_api(
            '/classes/{classSourcedId}/students/{studentSourcedId}/results', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ResultsType',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def put_result(self, body, sourced_id, **kwargs):  # noqa: E501
        """The REST create request message for the putResult() API call.  # noqa: E501

        ...not supplied...  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.put_result(body, sourced_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param SingleResultType body: ...tbd... (required)
        :param str sourced_id: ...tbd... (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.put_result_with_http_info(body, sourced_id, **kwargs)  # noqa: E501
        else:
            (data) = self.put_result_with_http_info(body, sourced_id, **kwargs)  # noqa: E501
            return data

    def put_result_with_http_info(self, body, sourced_id, **kwargs):  # noqa: E501
        """The REST create request message for the putResult() API call.  # noqa: E501

        ...not supplied...  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.put_result_with_http_info(body, sourced_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param SingleResultType body: ...tbd... (required)
        :param str sourced_id: ...tbd... (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'sourced_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method put_result" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `put_result`")  # noqa: E501
        # verify the required parameter 'sourced_id' is set
        if ('sourced_id' not in params or
                params['sourced_id'] is None):
            raise ValueError("Missing the required parameter `sourced_id` when calling `put_result`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'sourced_id' in params:
            path_params['sourcedId'] = params['sourced_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['OAuth2Security']  # noqa: E501

        return self.api_client.call_api(
            '/results/{sourcedId}', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
